Index: /trunk/src/samhain.c
===================================================================
--- /trunk/src/samhain.c	(revision 584)
+++ /trunk/src/samhain.c	(revision 1)
@@ -34,8 +34,15 @@
 #include <errno.h>
 
+
+#if TIME_WITH_SYS_TIME
+#include <sys/time.h>
+#include <time.h>
+#else
 #if HAVE_SYS_TIME_H
 #include <sys/time.h>
-#endif
+#else
 #include <time.h>
+#endif
+#endif
 
 #ifdef HAVE_MEMORY_H
@@ -56,21 +63,18 @@
 
 #include "samhain.h"
-#include "sh_pthread.h"
+#include "sh_files.h"
 #include "sh_utils.h"
 #include "sh_error.h"
 #include "sh_unix.h"
-#include "sh_files.h"
 #include "sh_getopt.h"
 #include "sh_readconf.h"
 #include "sh_hash.h"
-#include "sh_dbIO.h"
-#include "sh_restrict.h"
-
-#include "sh_nmail.h"
+
+#include "sh_mail.h"
 
 #include "sh_tiger.h"
-#include "sh_sig.h"
+#include "sh_gpg.h"
 #include "sh_mem.h"
-#include "sh_xfer.h"
+#include "sh_forward.h"
 #include "sh_tools.h"
 #include "sh_hash.h"
@@ -82,5 +86,4 @@
 #include "sh_ignore.h"
 #include "sh_prelink.h"
-#include "sh_sem.h"
 #endif
 
@@ -110,12 +113,8 @@
 volatile  int      sh_global_suspend_flag;
 volatile  int      sig_fresh_trail;        /* SIGIOT  */
-volatile  int      sh_thread_pause_flag = S_FALSE;
 volatile  int      sig_config_read_again;  /* SIGHUP  */
 volatile  int      sig_terminate;          /* SIGQUIT */
 volatile  int      sig_termfast;           /* SIGTERM */
 volatile  int      sig_force_check;        /* SIGTTOU */
-volatile  int      sig_force_silent;       /* SIGTSTP */
-volatile  int      sh_global_check_silent;
-volatile  int      sh_load_delta_flag;
 long int           eintr__result;
 char               sh_sig_msg[SH_MINIBUF];
@@ -138,60 +137,4 @@
 #endif
 
-#ifdef HAVE_PTHREAD
-struct gt {
-  size_t g_count;
-  char * g_glob;
-};
-
-pthread_key_t g_key;
-
-int sh_g_thread()
-{
-  struct gt * ptr = calloc(1,sizeof(struct gt));
-  if (!ptr)
-    return -1;
-  ptr->g_count    = 0;
-  ptr->g_glob     = calloc(1, SH_MAX_GLOBS * (GLOB_LEN+1));
-  if (!(ptr->g_glob))
-    {
-      free(ptr);
-      return -1;
-    }
-  return pthread_setspecific(g_key, ptr);
-}
-
-void sh_g_destroy(void * data)
-{
-  struct gt * ptr = (struct gt *) data;
-  free(ptr->g_glob);
-  free(ptr);
-  return;
-}
-
-void sh_g_init(void)
-{
-#if !defined(USE_SYSTEM_MALLOC) && defined(USE_MALLOC_LOCK)
-  extern int dnmalloc_pthread_init(void);
-  dnmalloc_pthread_init();
-#endif
-
-  if (0 != pthread_key_create(&g_key, sh_g_destroy))
-    {
-      perror("1");
-      exit(EXIT_FAILURE);
-    }
-
-  if (0 != sh_g_thread())
-    {
-      perror("2");
-      exit(EXIT_FAILURE);
-    }
-  return;
-}
-#define SH_G_INIT sh_g_init()
-#else
-#define SH_G_INIT ((void)0)
-#endif
-
 char * globber(const char * str)
 {
@@ -199,24 +142,14 @@
   size_t j;
 
-#ifndef HAVE_PTHREAD
+  static   size_t  items = 0;
   static   size_t  count = 0;
   static   char glob[SH_MAX_GLOBS * (GLOB_LEN+1)];
-#else
-  struct gt * ptr = pthread_getspecific(g_key);
-  size_t count;
-  char *  glob;
-
-  if (ptr) {
-    count = ptr->g_count;
-    glob  = ptr->g_glob;
-  } else {
+
+  if (str == NULL)
     return NULL;
-  }
-#endif
-
-  if (str != NULL)
+  else
     j = strlen(str);
-  else
-    return NULL;
+
+  ++items;
 
   ASSERT((j <= GLOB_LEN), _("j <= GLOB_LEN"))
@@ -230,4 +163,5 @@
     {
       count = 0;
+      items = 0;
     }
 
@@ -242,9 +176,5 @@
 
   i     = count;
-#ifdef HAVE_PTHREAD
-  ptr->g_count = count + j + 1;
-#else
   count = count + j + 1;
-#endif
   return &glob[i];
 }
@@ -263,7 +193,4 @@
 }
 
-#else
-/* not stealth */
-#define SH_G_INIT ((void)0)
 #endif
 
@@ -311,7 +238,4 @@
   ErrFlag[0] |= (1 << 11);
 #endif
-
-  sh.delayload = 0;
-
 #ifdef MKA_13
   ErrFlag[0] |= (1 << 12);
@@ -338,12 +262,5 @@
   sig_termfast           = 0;           /* SIGTERM */
   sig_force_check        = 0;           /* SIGTTOU */
-  sig_force_silent       = 0;           /* SIGTSTP */
-  sh_global_check_silent = 0;
-  sh_load_delta_flag     = 0;
-  sh_sig_msg[4] = '\0';
-  sh_sig_msg[3] = 'e';
-  sh_sig_msg[2] = 'n';
-  sh_sig_msg[1] = 'o';
-  sh_sig_msg[0] = 'N';
+  strcpy ( sh_sig_msg, _("None"));
 
 #ifdef MKB_01
@@ -380,8 +297,4 @@
 #endif
 
-  sh.pid = (UINT64) getpid();
-
-  sh.outpath = NULL;
-
   /* The flags.
    */
@@ -390,5 +303,4 @@
   sh.flag.update          = S_FALSE;
   sh.flag.opts            = S_FALSE;
-  sh.flag.started         = S_FALSE;
   if (is_samhainctl_init == S_FALSE)
     sh.flag.isdaemon        = S_FALSE;
@@ -406,5 +318,4 @@
   sh.flag.hidefile        = S_FALSE;
   sh.flag.loop            = S_FALSE;
-  sh.flag.inotify         = 0;
 
 #ifdef MKB_09
@@ -435,10 +346,6 @@
   /* The stats.
    */
-  sh.statistics.bytes_speed   = 0;
-  sh.statistics.bytes_hashed  = 0;
-  sh.statistics.files_report  = 0;
-  sh.statistics.files_error   = 0;
-  sh.statistics.files_nodir   = 0;
-
+  sh.statistics.bytes_speed  = 0;
+  sh.statistics.bytes_hashed = 0;
   sh.statistics.mail_success = 0;
   sh.statistics.mail_failed  = 0;
@@ -475,5 +382,5 @@
    */
   (void) sl_strlcpy (sh.host.name,  _("localhost"),  SH_MINIBUF);
-  sh.host.system[0]     = '\0'; /* flawfinder: ignore *//* ff bug */
+  sh.host.system[0]     = '\0';
   sh.host.release[0]    = '\0';
   sh.host.machine[0]    = '\0';
@@ -541,26 +448,14 @@
    */
 #if defined(SH_WITH_MAIL)
-  if (0 != strcmp (DEFAULT_MAILADDRESS, _("NULL")))
-    {
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_STRTOK_R)
-      char * saveptr;
-      (void) sl_strncpy(q, DEFAULT_MAILADDRESS, SH_PATHBUF);
-      p = strtok_r (q, ", \t", &saveptr);
-      if (p)
-	{
-	  (void) sh_nmail_add_compiled_recipient (p);
-	  while (NULL != (p = strtok_r (NULL, ", \t", &saveptr)))
-	    (void) sh_nmail_add_compiled_recipient (p);
-	}
-#else
+  if (0 == strcmp (DEFAULT_MAILADDRESS, _("NULL")))
+    {
       (void) sl_strncpy(q, DEFAULT_MAILADDRESS, SH_PATHBUF);
       p = strtok (q, ", \t");
       if (p)
 	{
-	  (void) sh_nmail_add_compiled_recipient (p);
+	  (void) sh_mail_setaddress_int (p);
 	  while (NULL != (p = strtok (NULL, ", \t")))
-	    (void) sh_nmail_add_compiled_recipient (p);
-	}
-#endif
+	    (void) sh_mail_setaddress_int (p);
+	}
     }
 #endif
@@ -647,54 +542,48 @@
   sh.looptime     = 60;
 
-#ifdef SCREW_IT_UP
-  sh.sigtrap_max_duration = 500000; /* 500ms */
-#endif
-
   /* The struct to hold privileged information.
    */
-  skey = calloc(1,sizeof(sh_key_t));
-  if (skey != NULL)
-    {
-
-      skey->mlock_failed = S_FALSE;
-      skey->rngI         = BAD;
-      /* properly initialized later 
-       */
-      skey->rng0[0] = 0x03; skey->rng0[1] = 0x09; skey->rng0[2] = 0x17;
-      skey->rng1[0] = 0x03; skey->rng1[1] = 0x09; skey->rng1[2] = 0x17;
-      skey->rng2[0] = 0x03; skey->rng2[1] = 0x09; skey->rng2[2] = 0x17;
-      
-      for (i = 0; i < KEY_BYT; ++i)
-	skey->poolv[i] = '\0';
-      
-      skey->poolc        = 0;
-      
-      skey->ErrFlag[0]   = ErrFlag[0];
-      ErrFlag[0]         = 0;
-      skey->ErrFlag[1]   = ErrFlag[1];
-      ErrFlag[1]         = 0;
-      
-      dez = &(TcpFlag[POS_TF-1][0]);
-      for (i = 0; i < PW_LEN; ++i)
-	{ 
-	  skey->pw[i] = (char) (*dez); 
-	  (*dez)      = '\0';
-	  ++dez; 
-	}
-      
-      skey->sh_sockpass[0]  = '\0';
-      skey->sigkey_old[0]   = '\0';
-      skey->sigkey_new[0]   = '\0';
-      skey->mailkey_old[0]  = '\0';
-      skey->mailkey_new[0]  = '\0';
-      skey->crypt[0]        = '\0'; /* flawfinder: ignore *//* ff bug */
-      skey->session[0]      = '\0';
-      skey->vernam[0]       = '\0';
-    }
-  else
+  skey = (sh_key_t *) malloc (sizeof(sh_key_t));
+  if (skey == NULL) 
     {
       perror(_("sh_init"));
       _exit (EXIT_FAILURE);
     }
+
+  skey->mlock_failed = SL_FALSE;
+  skey->rngI         = BAD;
+  /* properly initialized later 
+   */
+  skey->rng0[0] = 0x03; skey->rng0[1] = 0x09; skey->rng0[2] = 0x17;
+  skey->rng1[0] = 0x03; skey->rng1[1] = 0x09; skey->rng1[2] = 0x17;
+  skey->rng2[0] = 0x03; skey->rng2[1] = 0x09; skey->rng2[2] = 0x17;
+
+  for (i = 0; i < KEY_BYT; ++i)
+    skey->poolv[i] = '\0';
+
+  skey->poolc        = 0;
+
+  skey->ErrFlag[0]   = ErrFlag[0];
+  ErrFlag[0]         = 0;
+  skey->ErrFlag[1]   = ErrFlag[1];
+  ErrFlag[1]         = 0;
+
+  dez = &(TcpFlag[POS_TF-1][0]);
+  for (i = 0; i < PW_LEN; ++i)
+    { 
+       skey->pw[i] = (char) (*dez); 
+      (*dez)      = '\0';
+      ++dez; 
+    }
+
+  skey->sh_sockpass[0]  = '\0';
+  skey->sigkey_old[0]   = '\0';
+  skey->sigkey_new[0]   = '\0';
+  skey->mailkey_old[0]  = '\0';
+  skey->mailkey_new[0]  = '\0';
+  skey->crypt[0]        = '\0';
+  skey->session[0]      = '\0';
+  skey->vernam[0]       = '\0';
+
 
   sh_unix_memlock();
@@ -724,7 +613,8 @@
 #endif
 #if defined(SH_WITH_SERVER)
-  extern int sh_socket_remove (void);
-  extern int sh_html_zero();
-#endif
+  extern int sh_socket_remove ();
+#endif
+
+  SL_ENTER(_("exit_handler"));
 
 #if defined(SH_WITH_SERVER)
@@ -735,10 +625,7 @@
   for (modnum = 0; modList[modnum].name != NULL; ++modnum) 
     {
-      if (modList[modnum].initval == SH_MOD_ACTIVE)
+      if (modList[modnum].initval == GOOD)
 	(void) modList[modnum].mod_cleanup();
     }
-#ifdef HAVE_PTHREAD
-  sh_pthread_cancel_all();
-#endif
 #endif
 
@@ -748,5 +635,5 @@
   if (sh.mailNum.alarm_last > 0) 
     {
-      (void) sh_nmail_flush ();
+      (void) sh_mail_msg (NULL);
     }
 #endif
@@ -755,8 +642,5 @@
    */
 #if defined(SH_WITH_SERVER)
-  /* zero out the status file at exit, such that the status
-   * of client becomes unknown in the beltane interface
-   */
-  sh_html_zero();
+  sh_forward_html_write();
 #endif
 
@@ -767,27 +651,10 @@
   sh_files_deldirstack ();
   sh_files_delfilestack ();
-  sh_files_delglobstack ();
   sh_hash_hashdelete();
-  sh_files_hle_reg (NULL);
-  (void) sh_ignore_clean ();
-  /*
-   * Only flush on exit if running as deamon.
-   * Otherwise we couldn't run another instance
-   * while the deamon is running (would leave the
-   * deamon with flushed ruleset).
-   */
-  if (sh.flag.isdaemon == S_TRUE)
-    {
-      sh_audit_delete_all ();
-    }
 #endif
 #if defined(SH_WITH_SERVER)
-  sh_xfer_free_all ();
-#endif
-#if defined(SH_WITH_MAIL)
-  sh_nmail_free();
+  sh_forward_free_all ();
 #endif
   delete_cache();
-  sh_userid_destroy ();
   sh_mem_stat();
 #endif
@@ -799,19 +666,9 @@
   /* --- Checksum of executable. ---
    */
-  {
-    volatile  int sig_store = sig_termfast;
-
-    sig_termfast = 0;
-    (void) sh_unix_self_check();
-    sig_termfast = sig_store;
-  }
+  (void) sh_unix_self_check();
 
 
   /* --- Exit Message. ---
    */
-  if (sh.flag.exit == EXIT_FAILURE && !strcmp(sh_sig_msg, _("None")))
-    sl_strlcpy(sh_sig_msg, _("exit_failure"), SH_MINIBUF);
-  if (sh.flag.exit == EXIT_SUCCESS && !strcmp(sh_sig_msg, _("None")))
-    sl_strlcpy(sh_sig_msg, _("exit_success"), SH_MINIBUF);
   sh_error_handle ((-1), FIL__, __LINE__, sh.flag.exit, MSG_EXIT_NORMAL, 
 		   sh.prg_name, sh_sig_msg);
@@ -823,14 +680,16 @@
   /* --- Restrict error logging to stderr. ---
    */
+#ifdef WITH_MESSAGE_QUEUE
   close_ipc ();
+#endif
   sh_error_only_stderr (S_TRUE);
 
+
   /* --- Remove lock, delete critical information. ---
    */
   (void) sh_unix_rm_lock_file (sh.srvlog.name);
-  if (sh.flag.isdaemon == S_TRUE)
-    (void) sh_unix_rm_pid_file ();
+  (void) sh_unix_rm_pid_file ();
   if (skey != NULL)
-    memset (skey, 0, sizeof(sh_key_t));
+    memset (skey, (int) '\0', sizeof(sh_key_t));
   
   /* --- Exit. ---
@@ -854,38 +713,26 @@
 #if defined(__linux__) || defined(sun) || defined(__sun) || defined(__sun__)
 #include <dirent.h>
-static pid_t * procdirSamhain (void)
+static pid_t * procdirSamhain ()
 {
-  pid_t        * pidlist;
+  pid_t        * pidlist = malloc(sizeof(pid_t) * 65535);
   struct dirent * d;
   DIR *        dp;
   long         ino;
   struct stat  buf;
-  int          i;
+  int          i = 0;
   pid_t        pid, mypid = getpid();
   char       * tail;
   char         exef[128];
 
+  for (i = 0; i < 65535; ++i) pidlist[i] = 0;
+  i = 0;
+
   if (0 != stat(SH_INSTALL_PATH, &buf))
-    {
-      return NULL;
-    }
+    return NULL;
 
   ino = (long) buf.st_ino;
     
-  if (NULL == (dp = opendir(_("/proc"))))
-    {
-      /* cppcheck-suppress resourceLeak */
-      return NULL;
-    }
-
-  SH_MUTEX_LOCK(mutex_readdir);
-
-  pidlist =  calloc(1, sizeof(pid_t) * 65535);
-  if (!pidlist)
-    goto unlock_and_out;
-
-  for (i = 0; i < 65535; ++i) pidlist[i] = 0;
-
-  i = 0;
+  if (NULL == (dp = opendir("/proc")))
+    return NULL;
   while (NULL != (d = readdir(dp)) && i < 65535)
     {
@@ -908,14 +755,9 @@
 	}
     }
-
- unlock_and_out:
-  ;
-  SH_MUTEX_UNLOCK(mutex_readdir);
-
   closedir(dp);
   return pidlist;
 }
 #else
-static pid_t * procdirSamhain (void)
+static pid_t * procdirSamhain ()
 {
   return NULL;
@@ -966,7 +808,7 @@
   if (!fp)
     { if (errno != ENOENT) perror(_("fopen")); return 0; }
-  if (NULL == fgets(line, sizeof(line), fp))
-    { perror(_("fgets")); (void) sl_fclose(FIL__, __LINE__, fp); return 0; }
-  (void) sl_fclose(FIL__, __LINE__, fp); 
+  if (NULL == fgets(line, 255, fp))
+    { perror(_("fgets")); (void) fclose(fp); return 0; }
+  (void) fclose(fp); 
   p = line; 
   while (*p == ' '  || *p == '\f' || *p == '\n' || 
@@ -1016,17 +858,18 @@
   pid_t       * pidlist;
   int         i;
-#ifdef WCONTINUED
-      int wflags = WNOHANG|WUNTRACED|WCONTINUED;
-#else
-      int wflags = WNOHANG|WUNTRACED;
-#endif
-
-  fullpath = strdup (SH_INSTALL_PATH);
+
+
+  fullpath = malloc(strlen(SH_INSTALL_PATH)+1);
   if (fullpath == NULL)
-    { perror(_("strdup")); exit (1); }
-
-  argp[0]  = strdup (SH_INSTALL_PATH);
+    { perror(_("malloc")); exit (1); }
+  else
+    strcpy(fullpath, SH_INSTALL_PATH);                 /* known to fit  */
+
+  argp[0] = malloc(strlen(SH_INSTALL_PATH)+1);
   if (argp[0] == NULL)
-    { perror(_("strdup")); exit (1); }
+    { perror(_("malloc")); exit (1); }
+  else
+    strcpy(argp[0], SH_INSTALL_PATH);                  /* known to fit  */
+
 
   for (times = 1; times < 32; ++times)  argp[times] = NULL;
@@ -1036,7 +879,9 @@
   for (times = 2; times < res; ++times)  
     {
-      argp[times-1] = strdup (argv[times]);
+      argp[times-1] = malloc(strlen(argv[times])+1);
       if (argp[times-1] == NULL)
-	{ perror(_("strdup")); exit (1); }
+	{ perror(_("malloc")); exit (1); }
+      else
+	strcpy(argp[times-1], argv[times]);              /* known to fit  */
     }
 
@@ -1054,9 +899,9 @@
 	exit (1);
       case  0:
-	if (0 != sl_close_fd (FIL__, __LINE__, 0))
+	if (0 != close (0))
 	  {
 	    _exit(4);
 	  }
-	(void) execv(fullpath, argp); /* flawfinder: ignore *//* wtf? */
+	(void) execv(fullpath, argp); 
 	if (errno == EPERM)
 	  _exit(4);
@@ -1066,6 +911,6 @@
       default:
 	times = 0;
-	while (times < 300) {
-	  respid = waitpid(pid, &status, wflags);
+	while (times < 64) {
+	  respid = waitpid(pid, &status, WNOHANG|WUNTRACED);
 	  if ((pid_t)-1 == respid)
 	    {
@@ -1075,5 +920,4 @@
 	  else if (pid == respid)
 	    {
-#ifndef USE_UNO
 	      if (0 != WIFEXITED(status))
 		{
@@ -1083,12 +927,9 @@
 	      else
 		exit (1);
-#else
-	      exit (1);
-#endif
 	    }
 	  ++times;
 	  (void) retry_msleep(1, 0);
 	}
-	exit (0); /* assume that it runs ok */
+	exit (1);
       }
     }
@@ -1100,8 +941,5 @@
       pidlist = procdirSamhain ();
       if (pid == 0 && NULL == pidlist) /* pid file not found */ 
-	{
-	  free(fullpath);
-	  return (0);
-	}
+	return (0);
 	  
       status = 0;
@@ -1118,5 +956,4 @@
 	    }
 	}
-      free(fullpath);
       if (status == 7)
 	return 0;
@@ -1155,5 +992,5 @@
 	}
     }
-  free(fullpath); /* silence smatch false positive */
+
   exit (1); /* no exit handler installed yet */
   /*@notreached@*/
@@ -1185,5 +1022,5 @@
 /* Add a new schedule to the linked list of schedules
  */
-static sh_schedule_t * sh_set_schedule_int (const char * str, 
+static sh_schedule_t * sh_set_schedule_int (char * str, 
 					    sh_schedule_t * FileSchedIn, 
 					    /*@out@*/ int * status)
@@ -1198,5 +1035,5 @@
       FileSchedIn = NULL;
       *status = 0;
-      SL_RETURN(NULL, _("sh_set_schedule_int"));
+      return 0;
     }
 
@@ -1209,7 +1046,5 @@
       SL_RETURN(FileSchedIn , _("sh_set_schedule_int"));
     }
-  else {
-    FileSched->next = FileSchedIn;
-  }
+  FileSched->next = FileSchedIn;
   SL_RETURN(FileSched , _("sh_set_schedule_int"));
 }
@@ -1217,5 +1052,5 @@
 /* Add a new schedule to the linked list FileSchedOne
  */
-int sh_set_schedule_one (const char * str)
+int sh_set_schedule_one (char * str)
 {
   int status;
@@ -1226,5 +1061,5 @@
 /* Add a new schedule to the linked list FileSchedTwo
  */
-int sh_set_schedule_two (const char * str)
+int sh_set_schedule_two (char * str)
 {
   int status;
@@ -1233,285 +1068,4 @@
 }
 
-static int sh_flag_silent = S_FALSE;
-
-int sh_set_silent_full (const char * str)
-{
-  int status = sh_util_flagval(str, &sh_flag_silent);
-  return status;
-}
-
-
-void do_reconf()
-{
-  int status, modnum;
-
-  sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_RECONF);
-  
-  sh_thread_pause_flag = S_TRUE;
-
-  for (modnum = 0; modList[modnum].name != NULL; ++modnum) 
-    {
-      if (0 != (SH_MODFL_NEEDPAUSED & modList[modnum].flags) &&
-	  modList[modnum].initval == SH_MOD_THREAD)
-	{
-	  int count = 50;
-	  while (count && 0 == (SH_MODFL_ISPAUSED & modList[modnum].flags))
-	    retry_msleep(0, 100), --count;
-	}
-    }
-  
-#if defined(WITH_EXTERNAL)
-  /* delete list of external tasks
-   */
-  (void) sh_ext_cleanup();
-#endif
-#if defined(SH_WITH_MAIL)
-  sh_nmail_free();
-#endif
-  
-  /* delete the file list, make all database
-   * entries visible (allignore = FALSE)
-   */
-  (void) sh_files_deldirstack ();
-  (void) sh_files_delfilestack ();
-  (void) sh_files_delglobstack ();
-  (void) sh_ignore_clean ();
-  (void) hash_full_tree ();
-  sh_audit_delete_all ();
-  
-  
-#if defined(SH_WITH_CLIENT)
-  reset_count_dev_server();
-#endif
-#if defined(SH_WITH_CLIENT) || defined(SH_STANDALONE)
-  sh_restrict_purge ();
-  
-  
-  FileSchedOne = free_sched(FileSchedOne);
-  FileSchedTwo = free_sched(FileSchedTwo);
-  
-  for (modnum = 0; modList[modnum].name != NULL; ++modnum) 
-    {
-      /* sh_thread_pause_flag is true, and we block in lock
-       * until check has returned, so we are sure check will
-       * not run until sh_thread_pause_flag is set to false
-       */
-      /* if (modList[modnum].initval >= SH_MOD_ACTIVE) */
-      (void) modList[modnum].mod_reconf();
-    }
-#endif
-  
-  reset_count_dev_console();
-  reset_count_dev_time();
-  
-  (void) sh_unix_maskreset();
-  
-#ifdef RELOAD_DATABASE
-  sh_hash_hashdelete();
-
-  if (0 != sl_strcmp(file_path('D', 'R'), _("REQ_FROM_SERVER")))
-    {
-      char hashbuf[KEYBUF_SIZE];
-      (void) sl_strlcpy(sh.data.hash,
-			sh_tiger_hash (file_path('D', 'R'), 
-				       TIGER_FILE, TIGER_NOLIM, 
-				       hashbuf, sizeof(hashbuf)), 
-			KEY_LEN+1);
-    }
-#endif
-  (void) sl_trust_purge_user();
-  (void) sh_files_hle_reg (NULL);
-  (void) sh_prelink_run (NULL, NULL, 0, 0);
-  
-  /* --------------------------
-   * --- READ CONFIGURATION ---
-   * --------------------------
-   */
-  (void) sh_readconf_read ();
-  sig_config_read_again = 0;
-  (void) sh_files_setrec();
-  (void) sh_files_test_setup();
-  sh_audit_commit ();
-  
-  if (0 != sh.flag.nice)
-    {
-#ifdef HAVE_SETPRIORITY
-      setpriority(PRIO_PROCESS, 0, sh.flag.nice);
-#else
-      nice(sh.flag.nice);
-#endif
-    }
-  
-  if (sh.flag.checkSum == SH_CHECK_INIT)
-    {
-      sh.flag.isdaemon = S_FALSE;
-      sh.flag.loop     = S_FALSE;
-    }
-  
-  
-  /* --- Initialize modules. ---
-   */
-  TPT((0, FIL__, __LINE__, _("msg=<Initialize modules.>\n")));
-  for (modnum = 0; modList[modnum].name != NULL; ++modnum) 
-    {
-      status = modList[modnum].mod_init(&(modList[modnum]));
-      
-      if (status < 0)
-	{
-	  if (status == (-1)) {
-	    sh_error_handle (SH_ERR_NOTICE, FIL__, __LINE__, 
-			     status, MSG_MOD_FAIL,
-			     _(modList[modnum].name),
-			     status+SH_MOD_OFFSET);
-	  } else {
-	    sh_error_handle ((-1), FIL__, __LINE__, 
-			     status, MSG_MOD_FAIL,
-			     _(modList[modnum].name),
-			     status+SH_MOD_OFFSET);
-	  }
-	  modList[modnum].initval = SH_MOD_FAILED;
-	}
-      else
-	{
-	  sh_error_handle ((-1), FIL__, __LINE__, status, MSG_MOD_OK,
-			   _(modList[modnum].name));
-	  modList[modnum].initval = status;
-	}
-    }
-  
-  /* module is properly set up now
-   */
-  sh_thread_pause_flag = S_FALSE;
-
-  return;
-}
-
-static void check_signals (volatile int *flag_check_1, 
-			   volatile int * flag_check_2)
-{
-  if (sig_raised > 0) 
-    {
-      
-      TPT((0, FIL__, __LINE__, _("msg=<Process a signal.>\n")))
-	
-	if (sig_termfast == 1)  /* SIGTERM */
-	  {
-	    TPT((0, FIL__, __LINE__, _("msg=<Terminate.>\n")));
-	    --sig_raised; --sig_urgent;
-	    aud_exit (FIL__, __LINE__, EXIT_SUCCESS);
-	  }
-      
-      if (sig_force_check == 1) /* SIGTTOU / SIGTSTP */
-	{
-	  TPT((0, FIL__, __LINE__, _("msg=<Check run triggered.>\n")));
-	  *flag_check_1 = 1; *flag_check_2 = 1;
-	  sig_force_check = 0; --sig_raised;
-	  if (sig_force_silent)
-	    {
-	      sig_force_silent       = 0;
-	      sh_global_check_silent = (sh_flag_silent == S_FALSE) ? SH_SILENT_STD : SH_SILENT_FULL;
-	    }
-	  sh_sem_trylock();
-	}
-      
-      if (sig_config_read_again == 1 && /* SIGHUP */
-	  sh_global_suspend_flag == 0)
-	{
-	  TPT((0, FIL__, __LINE__, _("msg=<Re-read configuration.>\n")));
-	  do_reconf();
-	  --sig_raised;
-	}
-      
-      if (sig_fresh_trail == 1) /* SIGIOT */
-	{
-	  if (sh_global_suspend_flag == 0)
-	    {
-	      SH_MUTEX_LOCK(mutex_thread_nolog);
-	      
-	      /* Logfile access 
-	       */
-#ifdef SH_USE_XML
-	      (void) sh_log_file (NULL, NULL);
-#endif
-	      TPT((0, FIL__, __LINE__, _("msg=<Logfile stop/restart.>\n")));
-	      sh_error_only_stderr (S_TRUE);
-	      (void) sh_unix_rm_lock_file(sh.srvlog.name);
-	      (void) retry_msleep(3, 0);
-	      sh.flag.log_start = S_TRUE;
-	      sh_error_only_stderr (S_FALSE);
-	      sh_thread_pause_flag = S_FALSE;
-	      sig_fresh_trail       = 0;
-	      --sig_raised;
-	      SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	    }
-	}
-      
-      if (sig_terminate == 1)  /* SIGQUIT */
-	{
-	  TPT((0, FIL__, __LINE__, _("msg=<Terminate.>\n")));
-	  strncpy (sh_sig_msg, _("Quit"), 20);
-	  --sig_raised;
-	  aud_exit (FIL__, __LINE__, EXIT_SUCCESS);
-	}
-	  
-      if (sig_debug_switch == 1)  /* SIGUSR1 */
-	{
-	  TPT((0, FIL__, __LINE__, _("msg=<Debug switch.>\n")));
-	  sh_error_dbg_switch();
-	  sig_debug_switch = 0;
-	  --sig_raised;
-	}
-	  
-      if (sig_suspend_switch > 0)  /* SIGUSR2 */
-	{
-	  TPT((0, FIL__, __LINE__, _("msg=<Suspend switch.>\n")));
-	  if (sh_global_suspend_flag != 1) {
-	    SH_MUTEX_LOCK_UNSAFE(mutex_thread_nolog);
-	    sh_global_suspend_flag = 1;
-	    sh_error_handle((-1), FIL__, __LINE__, 0, MSG_SUSPEND, 
-			    sh.prg_name);
-	  } else {
-	    sh_global_suspend_flag = 0;
-	    SH_MUTEX_UNLOCK_UNSAFE(mutex_thread_nolog);
-	  }
-	  --sig_suspend_switch;
-	  --sig_raised; --sig_urgent;
-	}
-
-      if (sh_load_delta_flag > 0 &&
-	  sh_global_suspend_flag == 0)  /* DELTA Command */
-	{
-	  if (0 == sh_dbIO_load_delta())
-	    {
-	      --sh_load_delta_flag; --sig_raised;
-	    } 
-	}
-
-      sig_raised = (sig_raised < 0) ? 0 : sig_raised;
-      sig_urgent = (sig_urgent < 0) ? 0 : sig_urgent;
-      TPT((0, FIL__, __LINE__, _("msg=<End signal processing.>\n")));
-    }
-  return;
-}
-
-void check_for_delta_db()
-{
-  /* Need to contact the server.
-   */
-  if (sh_global_check_silent < SH_SILENT_FULL)
-    sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_CHECK_2);
-
-  if (sig_raised > 0 && sh_load_delta_flag > 0)  /* DELTA Command */
-    {
-      /* There was a DELTA Command
-       */
-      if (0 == sh_dbIO_load_delta())
-	{
-	  --sh_load_delta_flag; --sig_raised;
-	} 
-    }
-  return;
-}
-
 #endif
 
@@ -1521,15 +1075,11 @@
  *
  *******************************************************/
-#if !defined(SH_CUTEST)
 int main(int argc, char * argv[])
-#else
-int undef_main(int argc, char * argv[])
-#endif
 {
 #if defined(INET_SYSLOG)
-  extern int    sh_xfer_create_syslog_socket (int flag);
+  extern int    create_syslog_socket (int flag);
 #endif
 #if defined(SH_WITH_SERVER)
-  extern int    sh_create_tcp_socket(void);
+  extern int    sh_create_tcp_socket();
 #endif
 
@@ -1539,14 +1089,14 @@
   float         st_1, st_2;
   int           status;
-  volatile long          cct = 0; /* main loop iterations */
-
-  volatile int           flag_check_1 = 0;
-  volatile int           flag_check_2 = 0;
+  long          cct = 0; /* main loop iterations */
+
+  int           flag_check_1 = 0;
+  int           flag_check_2 = 0;
 
   int           check_done   = 0;
 #endif
 
-  volatile time_t        told;
-  volatile time_t        tcurrent;
+  time_t        told;
+  time_t        tcurrent;
   size_t        tzlen;
   char *        tzptr;
@@ -1554,23 +1104,10 @@
 
 #if defined (SH_STEALTH_NOCL)
-  char    command_line[256];
+  char  * command_line;
   int     my_argc = 0;
   char  * my_argv[32];
 #endif
 
-#if !defined(USE_SYSTEM_MALLOC)
-  typedef void assert_handler_tp(const char * error, const char *file, int line);
-  extern assert_handler_tp *dnmalloc_set_handler(assert_handler_tp *new);
-  (void) dnmalloc_set_handler(safe_fatal);
-#endif
-
-  SH_G_INIT; /* Must precede any use of _() */
-
   SL_ENTER(_("main"));
-
-  /* --- Close all but first three file descriptors. ---
-   */
-  sh_unix_closeall(3, -1, S_FALSE); /* at program start */
-
 
   if (argc >= 2 && 0 != getuid() &&
@@ -1673,15 +1210,10 @@
   /* Save the timezone.
    */
-  if (NULL != (tzptr = getenv("TZ"))) /* flawfinder: ignore */
+  if ((tzptr = getenv("TZ")) != NULL)
     {
       tzlen       = strlen(tzptr);
-      if (tzlen < 1024)
-	{
-	  sh.timezone = calloc(1, tzlen + 1);
-	  if (sh.timezone != NULL)
-	    (void) sl_strlcpy (sh.timezone, tzptr, tzlen + 1);
-	}
-      else
-	sh.timezone = NULL;
+       sh.timezone = malloc (tzlen + 1);
+      if (sh.timezone != NULL)
+	 (void) sl_strlcpy (sh.timezone, tzptr, tzlen + 1);
     }
   else
@@ -1691,9 +1223,11 @@
   /* --------  INIT  --------    
    */
-  sh_unix_ign_sigpipe();
 
   /* Restrict error logging to stderr.
    */
   sh_error_only_stderr (S_TRUE);
+
+  BREAKEXIT(sh_derr);
+  (void) sh_derr();
 
   /* Check that first three descriptors are open.
@@ -1714,10 +1248,4 @@
 #endif
 
-  /* --- First check for an attached debugger (after setting
-         sh.sigtrap_max_duration which has to be done before). ---
-   */
-  BREAKEXIT(sh_derr);
-  (void) sh_derr();
-
   /* --- Get local hostname. ---
    */
@@ -1730,6 +1258,4 @@
 
 #if !defined(SH_STEALTH_NOCL)
-  sh_argc_store = argc;
-  sh_argv_store = argv;
   (void) sh_getopt_get (argc, argv);
 #else
@@ -1737,22 +1263,14 @@
       strlen(argv[1]) > 0 && strlen(NOCL_CODE) > 0)
     {
-      if ( 0 == strcmp(argv[1], NOCL_CODE) )
-	{
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_STRTOK_R)
-	  char * saveptr;
-#endif
+      if ( 0 == strcmp(argv[1], NOCL_CODE) &&
+	   NULL != (command_line = (char *) SH_ALLOC(256 * sizeof(char))))
+	{
 	  my_argv[0] = argv[0]; ++my_argc;  
 	  command_line[0] = '\0';
-	  if (NULL != fgets (command_line, sizeof(command_line), stdin))
-	    command_line[sizeof(command_line)-1] = '\0';
-
+	  (void*) fgets (command_line, 255, stdin);
+	  command_line[255] = '\0';
 	  do {
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_STRTOK_R)
 	    my_argv[my_argc] = 
-	      strtok_r( (my_argc == 1) ? command_line : NULL, " \n", &saveptr);
-#else
-	    my_argv[my_argc] = 
-	      strtok( (my_argc == 1) ? command_line : NULL, " \n");
-#endif 
+	      strtok( (my_argc == 1) ? command_line : NULL, " \n"); 
 	    if (my_argv[my_argc] != NULL) {
 	      ++my_argc;
@@ -1761,9 +1279,6 @@
 	    }
 	  } while (my_argc < 32);
-
-	  sh_argc_store = my_argc;
-	  sh_argv_store = my_argv;
-
 	  (void) sh_getopt_get (my_argc, my_argv);
+	  SH_FREE (command_line);
 	}
       else
@@ -1776,4 +1291,9 @@
   sh.flag.opts = S_FALSE;
   
+
+  /* close all other files
+   */
+  sh_unix_closeall(3, -1); /* after processing CL options */
+
 
   /* --- Get user info. ---
@@ -1797,6 +1317,4 @@
   BREAKEXIT(sh_readconf_read);
   (void) sh_readconf_read ();
-
-  sh_calls_enable_sub();
 
 #if defined (SH_WITH_CLIENT) || defined (SH_STANDALONE)
@@ -1832,13 +1350,9 @@
     }
 
-  /* --- load database; checksum of database
-   */
-#if defined (SH_WITH_CLIENT) || defined (SH_STANDALONE)
-  if (0 == sh.delayload)
-    sh_hash_init_and_checksum();
-#endif
-
-  /* --- initialize signal handling etc.; fork daemon
-   */
+  /* initialize signal handling etc
+   */
+  if (sh.flag.isdaemon == S_TRUE)
+    sh_error_only_stderr (BAD);
+
   if (sh_unix_init(sh.flag.isdaemon) == -1) 
     {
@@ -1848,12 +1362,4 @@
     }
 
-#if defined (SH_WITH_CLIENT) || defined (SH_STANDALONE)
-  if (sh.delayload)
-    {
-      sleep(sh.delayload);
-      sh_hash_init_and_checksum();
-    }
-#endif
-
   /* --- drop privileges eventually ---
    */
@@ -1861,5 +1367,5 @@
   sh_create_tcp_socket ();
 #if defined(INET_SYSLOG)
-  sh_xfer_create_syslog_socket (S_TRUE);
+  create_syslog_socket (S_TRUE);
 #endif
   SL_REQUIRE(sl_policy_get_real(DEFAULT_IDENT) == SL_ENONE, 
@@ -1883,5 +1389,29 @@
    */
 #if defined(INET_SYSLOG) && defined(SH_WITH_SERVER)
-  sh_xfer_create_syslog_socket (S_FALSE);
+  create_syslog_socket (S_FALSE);
+#endif
+
+
+  /* checksum of database
+   */
+#if defined (SH_WITH_CLIENT) || defined (SH_STANDALONE) 
+  TPT((0, FIL__, __LINE__, _("msg=<Get checksum of the database.>\n")))
+  if (sh.flag.checkSum == SH_CHECK_CHECK) 
+    {
+      if (0 == sl_strcmp(file_path('D', 'R'), _("REQ_FROM_SERVER")))
+	{
+	  /* fetch the file from server to get checksum
+	   */
+	  sh_hash_init ();
+	  /* sh_hash_hashdelete (); */
+	}
+      else
+	{
+	  (void) sl_strlcpy(sh.data.hash,
+			    sh_tiger_hash (file_path('D', 'R'), 
+					   TIGER_FILE, 0), 
+			    KEY_LEN+1);
+	}
+    }
 #endif
 
@@ -1890,6 +1420,4 @@
    */
   sh_error_only_stderr (S_FALSE);
-
-  sh.flag.started = S_TRUE;
 
   /****************************************************
@@ -1901,7 +1429,9 @@
 #if defined(SH_WITH_SERVER) && !defined(SH_WITH_CLIENT)
 
-#if defined(WITH_GPG)
-  /* log startup */
-  sh_sig_log_startup ();
+#if (defined(WITH_GPG) || defined(WITH_PGP))
+  /* do nothing -- we exit earlier if error 
+  if (0 != sh_gpg_check_sign (1)) 
+    aud_exit(FIL__, __LINE__, EXIT_FAILURE);
+  */
 #else
   sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_START_1H,
@@ -1924,7 +1454,10 @@
   if (sh.flag.checkSum == SH_CHECK_CHECK) 
     {
-#if defined(WITH_GPG)
-      /* log startup */
-      sh_sig_log_startup ();
+#if (defined(WITH_GPG) || defined(WITH_PGP))
+      /* do nothing -- we exit earlier if error 
+	 if (0 != sh_gpg_check_sign (2)) 
+	 aud_exit(FIL__, __LINE__, EXIT_FAILURE);
+      */
+      ;
 #else
       sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_START_2H,
@@ -1936,7 +1469,10 @@
   else
     {
-#if defined(WITH_GPG)
-      /* log startup */
-      sh_sig_log_startup ();
+#if (defined(WITH_GPG) || defined(WITH_PGP))
+      /* do nothing -- we exit earlier if error 
+      if (0 != sh_gpg_check_sign (1)) 
+	aud_exit(FIL__, __LINE__, EXIT_FAILURE);
+      */
+      ;
 #else
       sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_START_1H,
@@ -1948,5 +1484,5 @@
 
  
-  if ((skey == NULL) || (skey->mlock_failed == S_TRUE))
+  if ((skey == NULL) || (skey->mlock_failed == SL_TRUE))
     sh_error_handle ((-1), FIL__, __LINE__, EPERM, MSG_MLOCK);
 
